{$A+,B-,D+,E-,F-,I+,L+,N-,O-,R-,S-,V+}
{$M 1024,0,0}
Program AnsiMem;
Uses
  DOS;

VAR
  Regs      : Registers;
  I,Ofset   : Word;
  Found     : Boolean;
  F         : Array[2..9] of Boolean;
  Rows      : Integer;
  Code      : Integer;
  RowInfo   : Byte;

Const
  AnsiArray : Array[2..9] of Byte = ($A2,$00,$AD,$00,$43,$4F,$4E,$20);

Procedure Search;
Begin
  Ofset := 0;
  Found := False;
  Repeat
    Found := False;
    FillChar(F[2],8,0);
    Ofset := Ofset + 2;
    If MemW[$800:Ofset] = $8013 then
    Begin
      For I := 2 TO 9 do
        If Mem[$0800:Ofset+I] = AnsiArray[I] then
          F[I] := True;
      Found := F[2] and F[3] and F[4] and F[5] and F[6] and F[7] and F[8] and F[9];
    End;
  Until Found or (Ofset >= $FFF0);
End;

Begin
  WriteLn('Please be patient.  Searching for ANSI.SYS in Memory...');
  Search;
  If Found then
  Begin
    WriteLn('ANSI.SYS Found!');
    Ofset := Ofset - 4;
    If ParamCount = 0 then
      Repeat
        Write('How many Rows does the display have? ');
        {$I-}
        ReadLn(RowS);
        {$I+}
      Until IOResult = 0
    ELSE
    Begin
      Val(ParamStr(1),Rows,Code);
      If Code <> 0 then
      Begin
        WriteLn('Invalid parameter');
        Halt(1);
      End;
    End;
    RowInfo := Rows;
    With Regs do
    Begin
      AH := $30;
      Intr($21,REGS);
      WriteLn('Patching ANSI.SYS for PC DOS version ',AL,'.',AH);
      Case AX of
        $0A03,$1403       : Begin
                              MemW[$0800:Ofset+$19D] := $9090;
                              MemW[$0800:Ofset+$1A1] := $9090;
                              Mem[$0800:Ofset+$17C]  := RowInfo;
                              Mem[$0800:Ofset+$40C]  := RowInfo;
                              Mem[$0800:Ofset+$48F]  := RowInfo;
                              Mem[$0800:Ofset+$183]  := Pred(RowInfo);
                            End;
        $0003,$0A02       : Begin
                              MemW[$0800:Ofset+$19D] := $9090;
                              MemW[$0800:Ofset+$19E] := $9090;
                              Mem[$0800:Ofset+$17C]  := RowInfo;
                              Mem[$0800:Ofset+$402]  := RowInfo;
                              Mem[$0800:Ofset+$485]  := RowInfo;
                              Mem[$0800:Ofset+$183]  := Pred(RowInfo);
                            End;
        $1E03             : Begin
                              MemW[$0800:Ofset+$19D] := $9090;
                              MemW[$0800:Ofset+$1A1] := $9090;
                              Mem[$0800:Ofset+$17C]  := RowInfo;
                              Mem[$0800:Ofset+$408]  := RowInfo;
                              Mem[$0800:Ofset+$48b]  := RowInfo;
                              Mem[$0800:Ofset+$183]  := Pred(RowInfo);
                            End;
      End;
    End;
  End
  Else
    WriteLn('ANSI.SYS not found!');
End.