{****************************************************************************}
{*                               SOUND TOOLS                                *}
{*                       Version 1.0, October 26, 1988                      *}
{*                                                                          *}
{*    Written by:                   Turbo Pascal sound generation tools.    *}
{*    Nels Anderson                                                         *}
{*    92 Bishop Drive               Released to the public domain.          *}
{*    Framingham, MA 01701                                                  *}
{*                                                                          *}
{****************************************************************************}

{ Sound effects demo }

Uses
  Crt,SoundEff;

Var
  c:  CHAR;
  soundnum:  INTEGER;

procedure MagicSound;
{ sound made when a spell is cast }
var
  z:  REAL;
begin
  z := 1;
  repeat
    Sound(Round((sin(z)+40)*50));
    Delay(11);
    z := z + 0.4
  until z >= 30;
  NoSound;
end; {MagicSound procedure}

begin {Main routine}
  repeat
    WriteLn('Select by Number:');
    WriteLn('1) Bat');
    WriteLn('2) Bird Call');
    WriteLn('3) Clock Tick');
    WriteLn('4) Conveyor');
    WriteLn('5) Crickets');
    WriteLn('6) Door Buzzer');
    WriteLn('7) Explosion');
    WriteLn('8) Phone Ringing');
    WriteLn('9) Flying Saucer');
    WriteLn('10) Siren');
    WriteLn('11) Drip');
    WriteLn('12) Train');
    WriteLn('13) Whoop');
    WriteLn('14) Phaser');
    WriteLn('15) Cuckoo');
    WriteLn('16) Uh oh');
    Write('Select sound, 0 to quit: ');
    ReadLn(soundnum);
    if soundnum > 0 then begin
      WriteLn('Hit a key to stop...');
      repeat
	case soundnum of
	  1:  SndEff(@Bat);
	  2:  SndEff(@BirdCall);
	  3:  SndEff(@Clocktick);
	  4:  SndEff(@Conveyor);
	  5:  SndEff(@Crickets);
	  6:  SndEff(@DoorBuzzer);
	  7:  SndEff(@Explosion);
	  8:  SndEff(@PhoneRing);
	  9:  SndEff(@FlyingSaucer);
	  10:  SndEff(@Siren);
	  11:  SndEff(@Drip);
	  12:  SndEff(@Train);
	  13:  SndEff(@Whoop);
	  14:  SndEff(@Phaser);
	  15:  begin SndEff(@Cuckoo);soundnum := 999;end;
	  16:  begin SndEff(@UhOh);soundnum := 999;end;
          17:  MagicSound;
	end; {case}
      until KeyPressed;
      c := ReadKey;
    end; {if soundnum > 0}
  until soundnum = 0;
end.
